//+---------------------------------------------------------------------+
//|                                       S_test_GenOfflineChart.mq4    |
//|                                                         Copyfree    |
//|                                        http://www.metaquotes.net    |
//| To drop this script on a M1 chart                                   |
//| Just duplicate M1 history into M7 history live for testing purpose  |
//| combined with I_test_M7_start_trace (see below)                     |
//+---------------------------------------------------------------------+
#property copyright "Copyfree 2011"
#property link      "http://www.metaquotes.net"
#property show_inputs

#import "user32.dll"
   int PostMessageA(int hWnd,int Msg,int wParam,int lParam);
   int RegisterWindowMessageA(string lpString);
#import
#include <WinUser32.mqh>

extern  int     offlineTimeFrame=7;
extern  bool    refreshOffline=true;
extern  bool    triggerOffline=false;

string      symbolName;
int         hstHandle;
int         hstFiller[13];
int         hstPtrPos;
datetime    prevTime;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
    int i;
//----
    if (!IsDllsAllowed())
    {
        Alert("To allow DLL import !");
        return (-1);
    }

    symbolName = Symbol();
    hstHandle = FileOpenHistory(symbolName + offlineTimeFrame + ".hst", FILE_BIN|FILE_WRITE);
   
    FileWriteInteger(hstHandle, 400, LONG_VALUE);                  // Version
    FileWriteString(hstHandle, "Copyfree 2011", 64);               // Copyright
    FileWriteString(hstHandle, symbolName, 12);                    // Symbol
    FileWriteInteger(hstHandle, offlineTimeFrame, LONG_VALUE);     // Periodicity
    FileWriteInteger(hstHandle, Digits, LONG_VALUE);               // Digits
    FileWriteInteger(hstHandle, 0, LONG_VALUE);                    // Time Sign
    FileWriteInteger(hstHandle, 0, LONG_VALUE);                    // Last Sync
    FileWriteArray(hstHandle, hstFiller, 0, 13);                   // Unused
    FileFlush(hstHandle);           // Write header record

    for (i = Bars - 1; i >= 0; i--)
    {
        FileWriteInteger(hstHandle, Time[i], LONG_VALUE);
        FileWriteDouble(hstHandle, Open[i], DOUBLE_VALUE);
        FileWriteDouble(hstHandle, Low[i], DOUBLE_VALUE);
        FileWriteDouble(hstHandle, High[i], DOUBLE_VALUE);
        FileWriteDouble(hstHandle, Close[i], DOUBLE_VALUE);
        FileWriteDouble(hstHandle, Volume[i], DOUBLE_VALUE);
        FileFlush(hstHandle);          // Write bar record
    }
    hstPtrPos = FileTell(hstHandle);
    prevTime = Time[0];
    signalOfflineChartWindow();
    
    while (IsStopped() == FALSE)
    {
        if (RefreshRates())
        {
            if(prevTime < Time[0])              // Bar shift
            {
                hstPtrPos = FileTell(hstHandle);
                prevTime = Time[0];
            }
            else                                // Same bar
                FileSeek(hstHandle, hstPtrPos, SEEK_SET);

            FileWriteInteger(hstHandle, Time[0], LONG_VALUE);
            FileWriteDouble(hstHandle, Open[0], DOUBLE_VALUE);
            FileWriteDouble(hstHandle, Low[0], DOUBLE_VALUE);
            FileWriteDouble(hstHandle, High[0], DOUBLE_VALUE);
            FileWriteDouble(hstHandle, Close[0], DOUBLE_VALUE);
            FileWriteDouble(hstHandle, Volume[0], DOUBLE_VALUE);
            FileFlush(hstHandle);          // (Re)write bar record
            signalOfflineChartWindow();
        }
    }
    
//----
   return(0);
  }

void    signalOfflineChartWindow()
{
    static  int winHandle;
        
    winHandle = WindowHandle(symbolName, offlineTimeFrame);
    if(winHandle != 0)
    {
        if(refreshOffline)  refreshOfflineChartWindow(winHandle);
        if(triggerOffline)  triggerOfflineChartWindow(winHandle);
    }
}

void    refreshOfflineChartWindow(int winHandle)
{
//  Does signal MT4 new data for the chart and triggers a tick on target chart
//  Issue: Indicator in M7 chart will reprocess full M7 history each tick
//  because IndicatorCounted() always returns 0
//  What command to not reset IndicatorCounted() of indicator and avoid unecessary CPU load ?

    if(winHandle != 0) PostMessageA(winHandle, WM_COMMAND, 33324, 0);
}

void    triggerOfflineChartWindow(int winHandle)
{
//  Does not signal MT4 new data for the chart but triggers a tick on target chart

    static  int MT4msgIdentifier;

    if(winHandle != 0)
    {
        if(MT4msgIdentifier == 0)       MT4msgIdentifier = RegisterWindowMessageA("MetaTrader4_Internal_Message");
        if(MT4msgIdentifier >= 0xC000)  PostMessageA(winHandle,MT4msgIdentifier,2,1);

// Note: msdn.microsoft.com RegisterWindowMessage Function
// If the message is successfully registered, the return value is a message identifier in the range 0xC000 through 0xFFFF.
    }
}

//+------------------------------------------------------------------+
//| script stopped, deinitialization function                        |
//+------------------------------------------------------------------+
void deinit()
{
    if (hstHandle >= 0)    FileClose(hstHandle);
}
//+------------------------------------------------------------------+
/*
//+------------------------------------------------------------------+
//|                                        I_test_M7_start_trace.mq4 |
//|                                                         Copyfree |
//|                                        http://www.metaquotes.net |
//| To drop this indicator on the M7 chart                           |
//| generated with S_test_GenOfflineChart                            |
//+------------------------------------------------------------------+

#property copyright "Copyfree 2011"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

//+---------------------------------------------+
int start()
{
    static  int         countedBars, count, now, msec;
    static  string      msecStr;

	countedBars=IndicatorCounted();
	if(countedBars<0) return(-1);

    now = GetTickCount();
    msec = MathMod(now,1000);
    msecStr = "00"+msec;

    Alert(TimeToStr(now/1000,TIME_SECONDS)+"."+StringSubstr(msecStr,StringLen(msecStr)-3,3)+
            ": "+Symbol()+"_"+Period()+": start() count="+count+"  Volume[0]="+Volume[0]+"  Close[0]="+Close[0]+"  Bars="+Bars+"  countedBars="+countedBars+
            "     --->   for ( i = "+(Bars-countedBars-1)+" ; i >= 0 ; i-- )");
    
    count++;

   return(0);
}
*/